package com.eactive.eai.batch.job.jobItem.ccrs;

import java.io.ByteArrayOutputStream;
import java.util.Properties;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_CCRSF_0620 extends DefaultTelegram implements TelegramService {

    private int SEND_LENGTH;       //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
    private int REAL_SEND_LENGTH;  //실제 송신할 전문의 총길이
    private Properties telegramInfo;

    /**
     * 생성자
     */
    public SEND_CCRSF_0620() {
        // 결번 전문 확인 요청
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {

            boolean result = calculateSendLength();
            if (!result) return false;

            //(송신길이)는 TCP/IP 프로토콜에서만 사용 자기 자신 포함 안함           
            compileField(0, ""+SEND_LENGTH, this.al_FieldProps[0]);

            //트랜잭션 코드 : 회원가기관의 주전산기(또는 중계기)를 위한 트랜잭션 구분자로 “CREDITFTP”를 사용한다.
            compileField(1, telegramInfo.getProperty(TelegramKeys.TRANSACTION_CODE), this.al_FieldProps[1]);

            //시스템 명칭 : 일괄전송 업무를 타 업무와 구분하기 위하여 사용하는 부호로 “FTP”를 사용한다.
            compileField(2, telegramInfo.getProperty(TelegramKeys.BIZ_GBN), this.al_FieldProps[2]);

            //회원기관코드 : 전문을 생성하여 발신하는 기관을 나타내기 위한 부호로 회원기관별로 유일하게 부여한다.(5.2 참조).
            // Ex) 국민: 004, 부산: 032, 농협: 011 등
            compileField(3, telegramInfo.getProperty(TelegramKeys.BANK_CODE), this.al_FieldProps[3]);

            //전문코드 : 전문을 구별하기 위하여 사용하는 기호로 전문 생성기관, 이용목적 등을 포함하고 있다(3.3 참조).
            compileField(4, this.getFldTelegramType(), this.al_FieldProps[4]);

            //업무구분코드 : 전문에 포함된 파일의 용도나 속성을 나타내기 위한 기호로 ‘표준보고서 양식’의 별칭을 사용한다(6.1~6.4  참조).
            compileField(5, batchDoc.getBatchMsg().getHeader().getBizCode(), this.al_FieldProps[5]);

            //전문 생성기관 : 전문을 작성한 기관을 나타내는 기호로 신용회복위원회가 생성한 경우 “C”를, 회원기관이 생성한 전문에는 “B”를 사용한다.
            compileField(6, telegramInfo.getProperty(TelegramKeys.TRA_FLAG_BANK), this.al_FieldProps[6]);

            //응답코드 : 전문의 처리결과를 나타내는 부호로 다음과 같이 설정한다.
            compileField(7, TelegramKeys.KFB_RET_CODE_SUCCESS, this.al_FieldProps[7]);

            // 여기부터는 개별부

            //송수신구분 : 적용업무를 구분하기 위한 기호
            //“S”: 파일송신(신용회복위원회가 회원기관에 파일을 전송)의 경우
            //“R”: 파일수신(회원기관이 신용회복위원회에 파일을 전송)
            compileField(8, getFldTrClass() , this.al_FieldProps[8]);

            //Block-NO
            compileField(9, ""+this.batchDoc.getBatchMsg().getBody().getBlockNum() , this.al_FieldProps[9]);

            //Sequence-NO
            compileField(10, ""+this.batchDoc.getBatchMsg().getBody().getSeqNum() , this.al_FieldProps[10]);

            //예비 필드
            compileField(11, "", this.al_FieldProps[11]);


            //<< 전문 완성

            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }

    public boolean doPostExecute() {
        try {
            if (!super.doPostExecute()) return false;

            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<8; i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=8; i< al_Field.size(); i++) {  //결번확인 필드는 비정형 필드로 바디 로그에서 제외
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            return true;

        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    public boolean doPreExecute() {

        try {
            if (!super.doPreExecute()) return false;
            telegramInfo = getTelegramInfo();
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return REAL_SEND_LENGTH;  //실 DATA BYTE수
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    private boolean calculateSendLength () {
        try {
            for (int i=1; i< this.al_Field.size(); i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                SEND_LENGTH += aField.length;
            }
            REAL_SEND_LENGTH = SEND_LENGTH;
            for (int i=0; i < 1 ; i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                REAL_SEND_LENGTH += aField.length;
            }
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        return super.getFieldValueString(4);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
        return super.getFieldValueString(8);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
        return super.getFieldValueString(7);
    }
}